# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class PathElement(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'node_type': 'str',
        'aspect_names': 'list[str]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'node_type': 'nodeType',
        'aspect_names': 'aspectNames'
    }

    def __init__(self, id=None, name=None, node_type=None, aspect_names=None, _configuration=None):  # noqa: E501
        """PathElement - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._name = None
        self._node_type = None
        self._aspect_names = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if node_type is not None:
            self.node_type = node_type
        if aspect_names is not None:
            self.aspect_names = aspect_names

    @property
    def id(self):
        """Gets the id of this PathElement.  # noqa: E501


        :return: The id of this PathElement.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PathElement.


        :param id: The id of this PathElement.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this PathElement.  # noqa: E501


        :return: The name of this PathElement.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PathElement.


        :param name: The name of this PathElement.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def node_type(self):
        """Gets the node_type of this PathElement.  # noqa: E501


        :return: The node_type of this PathElement.  # noqa: E501
        :rtype: str
        """
        return self._node_type

    @node_type.setter
    def node_type(self, node_type):
        """Sets the node_type of this PathElement.


        :param node_type: The node_type of this PathElement.  # noqa: E501
        :type: str
        """

        self._node_type = node_type

    @property
    def aspect_names(self):
        """Gets the aspect_names of this PathElement.  # noqa: E501


        :return: The aspect_names of this PathElement.  # noqa: E501
        :rtype: list[str]
        """
        return self._aspect_names

    @aspect_names.setter
    def aspect_names(self, aspect_names):
        """Sets the aspect_names of this PathElement.


        :param aspect_names: The aspect_names of this PathElement.  # noqa: E501
        :type: list[str]
        """

        self._aspect_names = aspect_names

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PathElement, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PathElement):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PathElement):
            return True

        return self.to_dict() != other.to_dict()
